<%@ WebHandler Language="C#" Class="ScriptReferenceExecutor" %>

using System;
using System.Web;
using System.Collections.Generic;
using System.Web.Script.Serialization;

public class ScriptReferenceExecutor : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {
        context.Response.ContentType = "text/plain";

        // context.Response.Write("alert('Message Received!');");

        JavaScriptSerializer serializer = new JavaScriptSerializer();
        Dictionary<string, string> headers = serializer.Deserialize<Dictionary<string, string>>(
            context.Request.QueryString["headers"]);
        string body = serializer.Deserialize<string>(context.Request.QueryString["body"]);
        string uniqueKey = serializer.Deserialize<string>(context.Request.QueryString["uniqueKey"]);

        string action = headers["action"];
        if (action == "normal")
        {
            this.SendResponse(context, uniqueKey, 200, "OK", "You've send: " + body);
        }
        else if (action == "error")
        {
            this.SendResponse(context, uniqueKey, 500, "Error", null);
        }
        else
        {
            System.Threading.Thread.Sleep(5000);
        }
    }

    private void SendResponse(HttpContext context, string uniqueKey, int statusCode, string statusText, string body)
    {
        context.Response.Write("Sys.Net.ScriptReferenceExecutor.complete('" + uniqueKey + "', ");
        context.Response.Write("'" + statusCode + "', ");
        context.Response.Write("'" + statusText + "', ");
        context.Response.Write(new JavaScriptSerializer().Serialize(body) + ");");
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}